function hparams = process_hparams(hparams)
    %% data settings
    if ~isfield(hparams,'fileNameBase')
        raise_field_missing('fileNameBase');
    end
    
    if ~isfield(hparams,'dataFileName')
        raise_field_missing('dataFileName');
    end
    
    if ~isfield(hparams,'dataSize')
        raise_field_missing('dataSize');
    end
    
    if ~isfield(hparams,'nFrames')
        raise_field_missing('nFrames');
    end

    if ~isfield(hparams,'jsonFile')
        hparams.jsonFile = '';
    end
    
    %% window settings
    if ~isfield(hparams,'windowSize')
        hparams.windowSize = 31;
    end
    
    if ~isfield(hparams,'boundaryWidth')
        hparams.boundaryWidth = 0;
    end
    
    %% seed settings
    if ~isfield(hparams,'numNegSeeds')
        hparams.numNegSeeds = 10;
    end
    
    if ~isfield(hparams,'maxShift')
        hparams.maxShift = 4;
    end
    
    if ~isfield(hparams,'distNeg')
        hparams.distNeg = 0.058*hparams.windowSize^1.5;
    end
    
    if ~isfield(hparams,'percSeeds')
        hparams.percSeeds = 0.4;
    end
    
    if ~isfield(hparams,'maskSize')
        hparams.maskSize = 1;
    end
    
    if ~isfield(hparams,'detNegSeeds')
        hparams.detNegSeeds = 1;
    end
    
    if ~isfield(hparams,'posSeedSize')
        hparams.posSeedSize = 1;
    end 
    
    %% oracle settings
    if ~isfield(hparams,'minSize')
        hparams.minSize = 40;
    end
    
    if ~isfield(hparams,'avgSize')
        hparams.avgSize = 150;
    end
    
    if ~isfield(hparams,'maxSize')
        hparams.maxSize = 400;
    end
    
    %% correlation space settings
    if ~isfield(hparams,'percSampleCorrspace')
        hparams.percSampleCorrspace = 0.32;
    end
    
    %% Sparse Comp settings
    if ~isfield(hparams,'percRows')
        hparams.percRows = 0.01;
    end
    
    if ~isfield(hparams,'percCols')
        hparams.percCols = 1.0;
    end
    
    if ~isfield(hparams,'nPcaComps')
        hparams.nPcaComps = 3;
    end
    
    if ~isfield(hparams,'gridRes')
        hparams.gridRes = 35;
    end
end

function raise_field_missing(name)
    error('%s is not defined.', name);
end